#---------------Fikser datasettet--------------------
Datadata$Dato=as.Date(Datadata$Dato)
DK_ts = as_tsibble(Datadata, index=Dato)


ny=Datadata%>%
  fill (2:14, .direction = "downup")       #Fyller inn verdier for NA

library("writexl")
write_xlsx(ny,"Data.xlsx")    #Lagrer ny excel-fil


#----------------HELE PERIODEN-----------------------
#Gjr om til tidsserie
Data$Dato=as.Date(Data$Dato)
DK_ts = as_tsibble(Data, index=Dato)

#Plotter strmprisen
plot(DK_ts$Dato,DK_ts$Ave_DK1,ylab = "Euro/MWh", type ="l",
     xlab = "r", main="Utvikling strmpris DK1 (2008-2021)", col=20)

#Sjekker stasjonaritet for alle varabler bde p niv- og differanseform (og for de ulike fasene)
adf.test((Datashitten$Ave_NO1))


adf.test((Datashitten$Ave_DK1))
adf.test(diff(Datashitten$Systempris))

adf.test((Datashitten$Kvote))
adf.test((Datashitten$Gass))
adf.test((Datashitten$Kull))
adf.test((Datashitten$Olje))
adf.test(diff(Datashitten$Vind_DK1))
adf.test((Datashitten$Totalvind_DK))
adf.test(diff(Datashitten$Vann_NO1))
adf.test((Datashitten$Vann_NORGE))
adf.test((Datashitten$Oslo.Middel))
adf.test((Datashitten$DK.Middel))

#Plotter ACF og PACF
acf(DK_ts$Ave_DK1, main="DK1 (hele perioden)")
pacf(DK_ts$Ave_DK1, main="DK1 (hele perioden)")

#LAGER DIFFERENSIERTE VARIABLER FOR  ORDNE OPP I STASJONARITET
DK_diff=diff(DK_ts$Ave_DK1)
NO_diff=diff(DK_ts$Ave_NO1)
Kvote_diff= diff(DK_ts$Kvote)
Kull_diff= diff(DK_ts$Kull)
Gass_diff= diff(DK_ts$Gass)
Olje_diff= diff(DK_ts$Olje)
DK.temp_diff=diff(DK_ts$DK.Middel)
Totalvind_diff=diff(DK_ts$Totalvind_DK)
Totalvann_diff=diff(DK_ts$Vann_NORGE)

DK_ts = DK_ts[-1,] #Fjerner frste rad av datasettet..

DK_ts$DK_diff=DK_diff        #legger til differansevariablene i datasettet
DK_ts$NO_diff=NO_diff
DK_ts$Kvote_diff=Kvote_diff
DK_ts$Kull_diff=Kull_diff
DK_ts$Gass_diff=Gass_diff
DK_ts$Olje_diff=Olje_diff
DK_ts$DK.temp_diff=DK.temp_diff
DK_ts$Totalvind_diff=Totalvind_diff
DK_ts$Totalvann_diff=Totalvann_diff

#Plotter strmprisen p difform
plot(DK_ts$Dato,DK_ts$DK_diff,ylab = "Euro/MWh", type ="l",
     xlab = "r", main="Utvikling strmpris DK1 (diff)", col=12)


acf(DK_ts$DK_diff, main="DK1_diff hele perioden")
pacf(DK_ts$DK_diff, main="DK1_diff hele perioden")

#-------ARIMA----------------- (sjekker for ulike lags og ulike variabler)
fit_arima= DK_ts %>% fill_gaps() %>%
  model(
    mod=ARIMA(DK_diff~Kvote_diff+Olje_diff, stepwise = FALSE),
    mod1=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff), stepwise = FALSE),
    mod2=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2), stepwise = FALSE),
    mod3=ARIMA(DK_diff~Kvote_diff+Oje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3), stepwise = FALSE),
    mod4=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4), stepwise = FALSE),
    mod5=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5), stepwise = FALSE),
    mod6=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6), stepwise = FALSE),
    mod7=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7), stepwise = FALSE),
    mod8=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8), stepwise = FALSE),
    mod9=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9), stepwise = FALSE),
    mod10=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10), stepwise = FALSE),
    mod11=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11), stepwise = FALSE),
    mod12=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12), stepwise = FALSE),
    mod13=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12)+lag(Kvote_diff,13), stepwise = FALSE),
    mod14=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12)+lag(Kvote_diff,13)+lag(Kvote_diff,14), stepwise = FALSE),
  )

fit_arima

glance(fit_arima) %>% arrange(AICc)   #Fr ut modellene rangert!

fit_arima %>%select(mod3) %>% report()   #Fr ut resultatene til modellen som kalles p. 

#Lager residuler for  tegne acf og pacf
resids=fit_arima %>%select(mod3) %>% residuals()

acf(resids, main="ARIMAX(5,1,0) med kvote, 14 lags kvote og gass(DK1)", na.action=na.pass)
pacf(resids, main="ARIMAX(5,1,0)(2,0,0) med kvote, 14 lags kvote og gass(DK1)", na.action = na.pass)

pacf(DK_ts$DK_diff, main="DK1_diff for hele perioden")

#Bar-plott
koeff.mod=c(0.4043, 0.1789, -0.5619, -0.7932, 0.3896, 0.9488, -0.2004, -0.5603, -0.2584, -0.0435, 0.2385, -0.4262, 0.0596, 0.9836, 0.0948)   #sett inn kvote koeffisientene til modellen
barplot(koeff.mod, main="Kvotevariabler til modell med kvote, 14 lags kvote og gass(DK1)", col="darkgreen") #, names=c("Kvote","Kvote(-1)", "Kvote(-2)", "Kvote(-3)", "Kvote(-4)", "Kvote(-5)"))


#Ljung-Box test

augment(fit_arima %>% select(mod14)) %>%features(.innov, ljung_box, lag = 22, dof = 21)



#------------------FASE 2------------------------
#Gjr om til tidsserie
Fase2$Dato=as.Date(Fase2$Dato)
Fase2_ts = as_tsibble(Fase2, index=Dato)

#Plotter strmprisen
plot(Fase2_ts$Dato,Fase2_ts$Ave_DK1,ylab = "Euro/MWh", type ="l",
     xlab = "r", main="Utvikling strmpris DK1", col=12)

#Plotter ACF og PACF
acf(Fase2_ts$Ave_DK1, main="DK1 fase 2")
pacf(Fase2_ts$Ave_DK1, main="DK1 fase 2")

#LAGER DIFFERENSIERTE VARIABLER FOR  ORDNE OPP I STASJONARITET
DK_diff=diff(Fase2_ts$Ave_DK1)
NO_diff=diff(Fase2_ts$Ave_NO1)
Kvote_diff= diff(Fase2_ts$Kvote)
Kull_diff= diff(Fase2_ts$Kull)
Gass_diff= diff(Fase2_ts$Gass)
Olje_diff= diff(Fase2_ts$Olje)
DK.temp_diff=diff(Fase2_ts$DK.Middel)
Totalvind_diff=diff(Fase2_ts$Totalvind_DK)
DK.vinf_diff=diff(Fase2_ts$Vind_DK1)

Fase2_ts = Fase2_ts[-1,] #Fjerner frste rad av datasettet..

Fase2_ts$DK_diff=DK_diff        #legger til differansevariablene i datasettet
Fase2_ts$NO_diff=NO_diff
Fase2_ts$Kvote_diff=Kvote_diff
Fase2_ts$Kull_diff=Kull_diff
Fase2_ts$Gass_diff=Gass_diff
Fase2_ts$Olje_diff=Olje_diff
Fase2_ts$DK.temp_diff=DK.temp_diff
Fase2_ts$Totalvind_diff=Totalvind_diff
Fase2_ts$DK.vind_diff=DK.vinf_diff

#Plotter strmprisen p difform
plot(Fase2_ts$Dato,Fase2_ts$DK_diff,ylab = "Euro/MWh", type ="l",
     xlab = "r", main="Utvikling strmpris DK1 (diff)", col=12)


acf(Fase2_ts$DK_diff, main="DK1 fase 2 (diff)")
pacf(Fase2_ts$DK_diff, main="DK1 fase 2 (diff)")

#-----------------ARIMA----------------- (bytter ut variabler for  sjekke ulike modller)
fit_arima2= Fase2_ts %>% fill_gaps() %>%
  model(
    mod=ARIMA(DK_diff~Kvote_diff+Olje_diff,stepwise = FALSE),
    mod1=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff), stepwise = FALSE),
    mod2=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2), stepwise = FALSE),
    mod3=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3), stepwise=FALSE),
    mod4=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4), stepwise=FALSE),
    mod5=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5), stepwise=FALSE),
    mod6=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6), stepwise=FALSE),
    mod7=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7), stepwise=FALSE),
    mod8=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8), stepwise=FALSE),
    mod9=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9), stepwise=FALSE),
    mod10=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10), stepwise=FALSE),
    mod11=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11), stepwise=FALSE),
    mod12=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12), stepwise=FALSE),
    mod13=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12)+lag(Kvote_diff,13), stepwise=FALSE),
    mod14=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12)+lag(Kvote_diff,13)+lag(Kvote_diff,14), stepwise=FALSE),
  )

fit_arima2


glance(fit_arima2) %>% arrange(BIC)   #Fr ut modellene rangert!

fit_arima2 %>%select(mod3) %>% report()   #Fr ut resultatene til modellen som kalles p. 

#Lager residuler for  tegne acf og pacf
resids=fit_arima2 %>%select(mod) %>% residuals()

acf(resids, main="SARIMAX(5,1,0)(1,0,0) med kvote,5 lags kvote og gass", na.action = na.pass)
pacf(resids,main="SARIMAX(5,1,0)(1,0,0) med kvote, 5 lags og gass",  na.action=na.pass)

pacf(Fase2_ts$DK_diff, main="DK_diff")

#Bar-plott
koeff.mod=c(0.1389, 0.0927, 0.7761, 0.4260, 0.1382, -0.6165)   #sett inn kvote koeffisientene til modellen
barplot(koeff.mod, main="Kvotevariabler til modell med kvote, 5 lags kvote og gass (DK1)", col="darkgreen", names=c("Kvote","Kvote(-1)", "Kvote(-2)", "Kvote(-3)", "Kvote(-4)", "Kvote(-5)"))

#Ljung-Box test
augment(fit_arima2 %>% select(mod3)) %>%features(.innov, ljung_box, lag = 14, dof =13)



#------------------FASE 3------------------------#
#Gjr om til tidsserie
Fase3$Dato=as.Date(Fase3$Dato)
Fase3_ts = as_tsibble(Fase3, index=Dato)

#Plotter strmprisen
plot(Fase3_ts$Dato,Fase3_ts$Ave_DK1,ylab = "Euro/MWh", type ="l",
     xlab = "r", main="Utvikling strmpris DK1 (2013-2020)", col=11)


#Plotter ACF og PACF
acf(Fase3_ts$Ave_DK1, main="DK1 fase 3")
pacf(Fase3_ts$Ave_DK1, main="DK1 fase 3")

#LAGER DIFFERENSIERTE VARIABLER FOR  ORDNE OPP I STASJONARITET
DK_diff=diff(Fase3_ts$Ave_DK1)
NO_diff=diff(Fase3_ts$Ave_NO1)
Kvote_diff= diff(Fase3_ts$Kvote)
Kull_diff= diff(Fase3_ts$Kull)
Gass_diff= diff(Fase3_ts$Gass)
Olje_diff= diff(Fase3_ts$Olje)
DK.temp_diff=diff(Fase3_ts$DK.Middel)
Totalvind_diff=diff(Fase3_ts$Totalvind_DK)
DK_vind_diff=diff(Fase3_ts$Vind_DK1)

Fase3_ts = Fase3_ts[-1,] #Fjerner frste rad av datasettet..

Fase3_ts$DK_diff=DK_diff        #legger til differansevariablene i datasettet
Fase3_ts$NO_diff=NO_diff
Fase3_ts$Kvote_diff=Kvote_diff
Fase3_ts$Kull_diff=Kull_diff
Fase3_ts$Gass_diff=Gass_diff
Fase3_ts$Olje_diff=Olje_diff
Fase3_ts$DK.temp_diff=DK.temp_diff
Fase3_ts$Totalvind_diff=Totalvind_diff
Fase3_ts$DK.vind_diff=DK_vind_diff

#Plotter strmprisen p difform
plot(Fase3_ts$Dato,Fase3_ts$DK_diff,ylab = "Euro/MWh", type ="l",
     xlab = "r", main="Utvikling strmpris DK1 (diff)", col=11)


acf(Fase3_ts$DK_diff, main="DK1 fase 3 (diff)")
pacf(Fase3_ts$DK_diff, main="DK1 fase 3 (diff)")

#-------------ARIMA----------------- (sjekker ulike variabler og lags)
fit_arima3= Fase3_ts %>% fill_gaps() %>%
  model(
    mod=ARIMA(DK_diff~Kvote_diff+Olje_diff, stepwise = FALSE),
    mod1=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff), stepwise = FALSE),
    mod2=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2), stepwise = FALSE),
    mod3=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3), stepwise = FALSE),
    mod4=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4), stepwise = FALSE),
    mod5=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5), stepwise = FALSE),
    mod6=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6), stepwise = FALSE),
    mod7=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7), stepwise = FALSE),
    mod8=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8), stepwise = FALSE),
    mod9=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9), stepwise = FALSE),
    mod10=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10), stepwise = FALSE),
    mod11=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11), stepwise = FALSE),
    mod12=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12), stepwise = FALSE),
    mod13=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12)+lag(Kvote_diff,13), stepwise = FALSE),
    mod14=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12)+lag(Kvote_diff,13)+lag(Kvote_diff,14), stepwise = FALSE),
  )

fit_arima3

glance(fit_arima3) %>% arrange(BIC)   #Fr ut modellene rangert!

fit_arima3 %>%select(mod1) %>% report()   #Fr ut resultatene til modellen som kalles p. 

#Lager residuler for  tegne acf og pacf
resids=fit_arima3 %>%select(mod3) %>% residuals()

acf(resids, main="ARIMAX(5,1,0) med kvote, 7 lags kvote og gass", na.action=na.pass)
pacf(resids, main="ARIMAX(5,1,0) med kvote, 7 lags kvote og gass", na.action=na.pass) #, na.action = na.pass)

acf(Fase3_ts$DK_diff, main="DK_diff fase 3")
pacf(Fase3_ts$DK_diff, main="DK_diff fase 3")


#Bar-plott
koeff.mod=c(0.4852, 0.1231, 0.4871, -0.3661, -0.5765, 0.4704, 0.9590, -0.5627)   #sett inn kvote koeffisientene til modellen
barplot(koeff.mod, main="Kvotevariabler til modell med kvote, 7 lags kvote og gass (DK1)", col="darkgreen", names=c("Kvote","Kvote(-1)", "Kvote(-2)", "Kvote(-3)", "Kvote(-4)", "Kvote(-5)", "Kvote(-6)", "Kvote(-7)"))


#Ljung Box test for hvit sty
augment(fit_arima3 %>% select(mod1)) %>%features(.innov, ljung_box, lag = 13, dof = 12)


resids3=residuals(arima.F3)  #Lager residuler 

acf(resids3, main="Residualer SARIMA(1,0,1)(0,0,4)7 ",lag.max = 100)
pacf(resids3, main=" ", lag.max=100)


plot(resids3$Dato,resids3$.resid,ylab = "", type ="l",
     xlab = "r", main="Residualer SARIMA(1,0,1)(0,0,4)7", col=20,)


#------------------FASE 4------------------------
#Gjr om til tidsserie
Fase4$Dato=as.Date(Fase4$Dato)
Fase4_ts = as_tsibble(Fase4, index=Dato)

#Plotter strmprisen
plot(Fase4_ts$Dato,Fase4_ts$Ave_DK1,ylab = "Euro/MWh", type ="l",
     xlab = "r", main="Utvikling strmpris DK1 Fase 4", col=10)


#Plotter ACF og PACF
acf(Fase4_ts$Ave_DK1, main="DK1 fase 4")
pacf(Fase4_ts$Ave_DK1, main="DK1 fase 4")

#LAGER DIFFERENSIERTE VARIABLER FOR  ORDNE OPP I STASJONARITET
DK_diff=diff(Fase4_ts$Ave_DK1)
NO_diff=diff(Fase4_ts$Ave_NO1)
Kvote_diff= diff(Fase4_ts$Kvote)
Kull_diff= diff(Fase4_ts$Kull)
Gass_diff= diff(Fase4_ts$Gass)
Olje_diff= diff(Fase4_ts$Olje)
DK.temp_diff=diff(Fase4_ts$DK.Middel)
Totalvind_diff=diff(Fase4_ts$Totalvind_DK)
DK.vind_diff=diff(Fase4_ts$Vind_DK1)

Fase4_ts = Fase4_ts[-1,] #Fjerner frste rad av datasettet..

Fase4_ts$DK_diff=DK_diff        #legger til differansevariablene i datasettet
Fase4_ts$NO_diff=NO_diff
Fase4_ts$Kvote_diff=Kvote_diff
Fase4_ts$Kull_diff=Kull_diff
Fase4_ts$Gass_diff=Gass_diff
Fase4_ts$Olje_diff=Olje_diff
Fase4_ts$DK.temp_diff=DK.temp_diff
Fase4_ts$Totalvind_diff=Totalvind_diff
Fase4_ts$DK1.vind_diff=DK.vind_diff

#Plotter strmprisen p difform
plot(Fase4_ts$Dato,Fase4_ts$DK_diff,ylab = "Euro/MWh", type ="l",
     xlab = "r", main="Utvikling strmpris DK1 (diff)", col=10)


acf(Fase4_ts$DK_diff, main="DK1 fase 4 (diff)")
pacf(Fase4_ts$DK_diff, main="DK1 fase 4 (diff)")

#-----------------------ARIMA...............................(sjekker for ulike variabler og lags)
fit_arima4= Fase4_ts %>% fill_gaps() %>%
  model(
    mod=ARIMA(DK_diff~Kvote_diff+Olje_diff, stepwise = FALSE),
    mod1=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff), stepwise = FALSE),
    mod2=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2), stepwise = FALSE),
    mod3=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3), stepwise = FALSE),
    mod4=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4), stepwise = FALSE),
    mod5=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5), stepwise = FALSE),
    mod6=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6), stepwise = FALSE),
    mod7=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7), stepwise = FALSE),
    mod8=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8), stepwise = FALSE),
    mod9=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9), stepwise = FALSE),
    mod10=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10), stepwise = FALSE),
    mod11=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11), stepwise = FALSE),
    mod12=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12), stepwise = FALSE),
    mod13=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12)+lag(Kvote_diff,13), stepwise = FALSE),
    mod14=ARIMA(DK_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7)+lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12)+lag(Kvote_diff,13)+lag(Kvote_diff,14), stepwise = FALSE),
  )

fit_arima4

glance(fit_arima4) %>% arrange(BIC)   #Fr ut modellene rangert!

fit_arima4 %>%select(mod3) %>% report()   #Fr ut resultatene til modellen som kalles p. 

#Lager residualer for  tegne acf og pacf
resids=fit_arima4 %>%select(mod3) %>% residuals()

acf(resids, main="ARIMAX(5,1,0) med kvote, 14 lags kvote og gass(DK1)", na.action = na.pass)
pacf(resids, main="ARIMAX(5,1,0) med kvote 14 lags kvote og gass(DK1)", na.action=na.pass)

acf(Fase4_ts$DK_diff, main="DK_diff fase 4")
pacf(Fase4_ts$DK_diff, main="DK_diff fase 4")


#Bar-plott
koeff.mod=c(0.4235, -0.9966, -2.7622, -0.1226, 1.3353, 1.5256, 1.5013, -1.6395, -1.0072, 0.3091, 2.5764, -1.8810, 0.1255, 0.9090, 0.4477)   #sett inn kvote koeffisientene til modellen
barplot(koeff.mod, main="Kvotevariabler til modell med kvote, 14 lags og gass(DK1)", col="darkgreen") #, names=c("Kvote","Kvote(-1)", "Kvote(-2)", "Kvote(-3)", "Kvote(-4)", "Kvote(-5)", "Kvote(-6)", "Kvote(-7)"))


#Ljung-Box test
augment(fit_arima4 %>% select(mod)) %>%features(.innov, ljung_box, lag = 10, dof = 7)


#----------------------- ULIKE PLOT ------------------------
plot(DK_ts$Dato,DK_ts$Kvote,ylab = "Euro/tonn", type ="l",
     xlab = "", main="Utvikling kvotepris(2008-2022*)", col="darkgreen", cex.main=0.75)+
  theme_minimal()  #Skal gjre bakgrunnen hvit


plot(DK_ts$Dato,DK_ts$Ave_DK1,ylab = "Euro/tonn", type ="l",
     xlab = "r", main="Utvikling strmpris DK1 (2008-2021)", col="darkgreen", cex.main=0.75)+
  theme_minimal()  #Skal gjre bakgrunnen hvit



#Plotter Kvote, DK1 og NO1  (Hele perioden)
intdef_l = DK_ts[c("Dato","Ave_NO1","Ave_DK1", "Kvote")]
intdef_l = intdef_l %>% gather(Ave_NO1, Ave_DK1, Kvote, key="variable", value=value)

ggplot(intdef_l, aes(Dato, value)) +
  geom_line() +
  facet_wrap(~variable, nrow=3)+
  theme_minimal()  


#Plotter DK1, NO1 og Kvotepris i samme plot (Hele perioden)
DK_df = DK_ts %>% select(Dato, Ave_NO1,Ave_DK1, Kvote)
colnames(DK_df) = c("r", "NO1", "DK1", "EU ETS")

DK_df %>% pivot_longer(-r, names_to="Prisomrder", values_to = "Euro") %>% 
  ggplot(aes(x=r, y=Euro, colour=Prisomrder)) + 
  geom_line(lwd=0.1,alpha=0.55)+theme_bw()


# Plott kun strmpriser
DK_df = DK_ts %>% select(Dato, Ave_NO1,Ave_DK1)
colnames(DK_df) = c("r", "NO1", "DK1")

DK_df %>% pivot_longer(-r, names_to="Prisomrder", values_to = "Euro") %>% 
  ggplot(aes(x=r, y=Euro, colour=Prisomrder)) + 
  geom_line(lwd=0.1,alpha=0.55)+theme_bw()+theme_minimal()


#Plott gass osv. i samme
DK_df = DK_ts %>% select(Dato, Gass, Kull)
colnames(DK_df) =c("r", "Gass", "Kull")

DK_df %>% pivot_longer(-r, names_to="Priser", values_to = "Euro") %>% 
  ggplot(aes(x=r, y=Euro, colour=Priser)) + 
  geom_line(lwd=0.1,alpha=0.55)+theme_bw()





#Plotter DK1, diff(DK1), NO1, diff(NO1)
DK.1 = DK_ts[c("Dato","Ave_NO1","NO_diff","Ave_DK1", "DK_diff")]
DK.1 = DK.1 %>% gather(Ave_NO1, NO_diff, Ave_DK1, DK_diff, key="variable", value=value)

ggplot(DK.1,aes(Dato, value)) +    #colour=variable gir forskjellig farge p de ulike grafene
  geom_line() + 
  facet_wrap(~variable, nrow=2)+ labs(x="r", y="Euro")+
  theme_minimal() #Fikser hvit bakgrunn (bde p plot og overskrift)

#---
DK.1 = DK_ts[c("Dato","Ave_DK1","DK_diff")]
DK.1 = DK.1 %>% gather(Ave_DK1, DK_diff, key="variable", value=value)

ggplot(DK.1,aes(Dato, value)) +
  geom_line() + 
  facet_wrap(~variable, nrow=2)+ labs(x="r", y="Euro")+
  theme_minimal()


#.... PLOTTER NO1 OG NO1_DIFF SAMMEN
DK2 = DK_ts %>% select(Dato, Ave_NO1, NO_diff)
colnames(DK2) = c("r", "NO1","NO_diff")

DK2 %>% pivot_longer(-r, names_to="Utvikling", values_to = "Euro") %>% 
  ggplot(aes(x=r, y=Euro, colour=Utvikling)) + 
  geom_line(alpha=0.8, lwd=0.5)+
  theme_bw()




#Plotter DK1, diff(DK1), NO1, diff(NO1) -> FASE2
DK.1 = Fase2_ts[c("Dato","Ave_NO1","NO_diff","Ave_DK1", "DK_diff")]
DK.1 = DK.1 %>% gather(Ave_NO1, NO_diff, Ave_DK1, DK_diff, key="variable", value=value)

ggplot(DK.1,aes(Dato, value)) +    #colour=variable gir forskjellig farge p de ulike grafene
  geom_line(lwd=0.25) + 
  facet_wrap(~variable, nrow=2)+ labs(x="r", y="Euro")+
  theme_minimal() #Fikser hvit bakgrunn (bde p plot og overskrift)


#Plotter  strmpris NO1 for 2021 -> til innledningen
data2021$Dato=as.Date(data2021$Dato)
data2021_ts = as_tsibble(data2021, index=Dato)


plot(data2021_ts$Dato,data2021_ts$Ave_NO1,ylab = "Euro/MWh", type ="l",
     xlab = " ", main="Utvikling strmpris NO1 2021", col="darkblue")


# plott av gasspris

plot(DK_ts$Dato,DK_ts$Gass,ylab = "Euro/MWh", type ="l",
     xlab = "", main=" ", col="orange", cex.main=0.75)+
  theme_minimal()  #Skal gjre bakgrunnen hvit




#plott av kullpris

plot(DK_ts$Dato,DK_ts$Kull,ylab = "Dollar/tonn", type ="l",
     xlab = "", main=" ", col="grey", cex.main=0.75)+
  theme_minimal()  #Skal gjre bakgrunnen hvit
