#laster inn nødvendige pakker 

library(tidyverse)
library(fpp3)
library(lubridate)
library(dynlm)
library(dplyr)
library(tseries)

library(stargazer)  
library(dynlm)
library(zoo)
library(foreign)
library(tidyverse)
library(fpp3)
library(ggplot2)
library(fable)
library(fabletools)
library(tsibble)
library(GGally)


#fikser datasettet til tidsserie 
Data$Dato =  as.Date(Data$Dato, format="%Y-%m-%d")
NO_ts = as_tsibble(Data, index=Dato)



#gjør om prisvariabler til diff-form 
NO1_diff=diff(NO_ts$Ave_NO1) 
Kvote_diff=diff(NO_ts$Kvote)
Gass_diff=diff(NO_ts$Gass)
Olje_diff=diff(NO_ts$Olje)
Kull_diff=diff(NO_ts$Kull)

Vann_diff=diff(NO_ts$Vann_NORGE)
Vann_diff_NO1=diff(NO_ts$Vann_NO1)
Vind_diff=diff(NO_ts$Totalvind_DK)
Vind_diff_DK1=diff(NO_ts$Vind_DK1)
Oslo_diff=diff(NO_ts$Oslo.Middel)

DK1_diff=diff(NO_ts$Ave_DK1)


NO_ts2 = NO_ts[-1,] #fjerner første rad for å unngå problemer med NA 

#Legger til de nye variablene i datasettet

NO_ts2$NO1_diff=NO1_diff[!is.na(NO1_diff)]
NO_ts2$Kvote_diff=Kvote_diff[!is.na(Kvote_diff)]
NO_ts2$Olje_diff=Olje_diff[!is.na(Olje_diff)]
NO_ts2$Gass_diff=Gass_diff[!is.na(Gass_diff)]
NO_ts2$Kull_diff=Kull_diff[!is.na(Kull_diff)]

NO_ts2$Vann_diff=Vann_diff[!is.na(Vann_diff)]
NO_ts2$Vann_diff_NO1=Vann_diff_NO1[!is.na(Vann_diff_NO1)]
NO_ts2$Vind_diff=Vind_diff[!is.na(Vind_diff)]
NO_ts2$Vind_diff_DK1=Vind_diff_DK1[!is.na(Vind_diff_DK1)]
NO_ts2$Oslo_diff=Oslo_diff[!is.na(Oslo_diff)]

NO_ts2$DK1_diff=DK1_diff[!is.na(DK1_diff)]

#deler datasettet opp i de 3 fasene: 
NO_ts2$periode=as.numeric(format(NO_ts2$Dato, "%Y"))
fase2=subset(NO_ts2, periode<=2012)
fase2=as_tsibble(fase2, index=Dato)

fase3=subset(NO_ts2, periode<=2020 & periode>=2013)
fase3$Dato=as.Date(fase3$Dato)
fase3=as_tsibble(fase3, index=Dato)

fase4=subset(NO_ts2, periode>=2021)
fase4$Dato=as.Date(fase4$Dato)






#sjekker stasjonaritet på nivåform
adf.test(fase4$Ave_NO1)
adf.test(fase4$Ave_DK1)
adf.test(fase4$Kvote)
adf.test(fase4$Gass)
adf.test(fase4$Kull)
adf.test(fase4$Olje)
adf.test(fase4$Vann_NO1)
adf.test(fase4$Vann_NORGE)
adf.test(fase4$Oslo.Middel)
adf.test(fase4$DK.Middel)
adf.test(fase4$Vind_DK1)
adf.test(fase4$Totalvind_DK)

#sjekke stasjonaritet på diff-form 

adf.test(diff(fase4$Ave_NO1))
adf.test(diff(fase4$Ave_DK1))
adf.test(diff(fase4$Kvote))
adf.test(diff(fase4$Gass))
adf.test(diff(fase4$Kull))
adf.test(diff(fase4$Olje))
adf.test(diff(fase4$Vann_NO1))
adf.test(diff(fase4$Vann_NORGE))
adf.test(diff(fase4$Oslo.Middel))
adf.test(diff(fase4$DK.Middel))
adf.test(diff(fase4$Vind_DK1))
adf.test(diff(fase4$Totalvind_DK))



######################kartlegging av strømmarkedet 

#kjører strøm+kvote og så ulike variabler 
fit_2variabler= fase4%>% fill_gaps() %>%
  model(
    mod0=ARIMA(NO1_diff, stepwise=FALSE),
    mod1=ARIMA(NO1_diff~Kvote_diff, stepwise=FALSE),
    mod2=ARIMA(NO1_diff~Kvote_diff+Gass_diff, stepwise=FALSE), 
    mod3=ARIMA(NO1_diff~Kvote_diff+Kull_diff, stepwise=FALSE), 
    mod4=ARIMA(NO1_diff~Kvote_diff+Olje_diff, stepwise=FALSE), 
    mod5=ARIMA(NO1_diff~Kvote_diff+Totalvind_DK, stepwise=FALSE),
    mod52=ARIMA(NO1_diff~Kvote_diff+Vind_DK1, stepwise=FALSE),
    mod5d=ARIMA(NO1_diff~Kvote_diff+Vind_diff, stepwise=FALSE), 
    mod52d=ARIMA(NO1_diff~Kvote_diff+Vind_diff_DK1, stepwise=FALSE),
    mod6=ARIMA(NO1_diff~Kvote_diff+Vann_NORGE, stepwise=FALSE),
    mod62=ARIMA(NO1_diff~Kvote_diff+Vann_NO1, stepwise=FALSE),
    mod6d=ARIMA(NO1_diff~Kvote_diff+Vann_diff, stepwise=FALSE),
    mod62d=ARIMA(NO1_diff~Kvote_diff+Vann_diff_NO1, stepwise=FALSE),
    mod7=ARIMA(NO1_diff~Kvote_diff+Oslo.Middel, stepwise=FALSE), 
    mod7d=ARIMA(NO1_diff~Kvote_diff+Oslo_diff, stepwise=FALSE)
    
    
  )

fit_2variabler
glance(fit_2variabler)
glance(fit_2variabler) %>% arrange(AICc)
fit_2variabler %>%select(mod0) %>% report()
fit_2variabler %>%select(mod5d) %>% report()



#ljung box test og plotting av residualer 
augment(fit_2variabler %>% select(mod0)) %>%features(.innov, ljung_box, lag =10, dof=6)

fit_2variabler %>%select(mod2) %>%gg_tsresiduals()
resids_2var=fit_2variabler %>%select(mod2) %>% residuals()

acf(resids_2var, na.action=na.pass) 
pacf(resids_2var, na.action=na.pass)


fit_3variabler= fase4 %>% fill_gaps() %>%
  model(
    mod0=ARIMA(NO1_diff, stepwise=FALSE),
    mod1=ARIMA(NO1_diff~Kvote_diff, stepwise=FALSE),
    mod2=ARIMA(NO1_diff~Kvote_diff+Gass_diff, stepwise=FALSE), 
    mod3=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Kull_diff, stepwise=FALSE),
    mod4=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Olje_diff, stepwise=FALSE),
    mod5=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vann_NORGE, stepwise=FALSE),
    mod52d=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vann_diff, stepwise=FALSE),
    mod6=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff, stepwise=FALSE),
    mod7=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Oslo_diff, stepwise=FALSE)
    
    
  )

fit_3variabler
glance(fit_3variabler)
glance(fit_3variabler) %>% arrange(AICc)
fit_3variabler %>%select(mod6) %>% report()
fit_3variabler %>%select(mod7) %>% report()


resids_3var=fit_3variabler %>%select(mod7) %>% residuals()

acf(resids_3var, na.action=na.pass) 
pacf(resids_3var, na.action=na.pass)

fit_4variabler= fase4 %>% fill_gaps() %>%
  model(
    mod_1=ARIMA(NO1_diff),
    mod_2=ARIMA(NO1_diff~Kvote_diff),
    mod_3=ARIMA(NO1_diff~Kvote_diff+Gass_diff), 
    mod_4=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff),
    mod_4kull=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Kull_diff),
    mod_4olje=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Olje_diff),
    mod_4vann=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Vann_NORGE),
    mod_4vanndiff=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Vann_diff),
    mod_4oslo=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Oslo_diff)
    
    
    
  )

fit_4variabler
glance(fit_4variabler)
glance(fit_4variabler) %>% arrange(AICc)
fit_4variabler %>%select(mod_4oslo) %>% report()


fit_5variabler= fase4 %>% fill_gaps() %>%
  model(
    mod_1=ARIMA(NO1_diff),
    mod_2=ARIMA(NO1_diff~Kvote_diff),
    mod_3=ARIMA(NO1_diff~Kvote_diff+Gass_diff), 
    mod_4=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff),
    mod_5=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Oslo_diff),
    mod_5kull=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Oslo_diff+Kull_diff),
    mod_5olje=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Oslo_diff+Olje_diff),
    mod_5vann=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Oslo_diff+Vann_NORGE),
    mod_5vanndiff=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Oslo_diff+Vann_diff)
    
  )

fit_5variabler
glance(fit_5variabler)
glance(fit_5variabler) %>% arrange(AICc)

fit_6variabler= fase4 %>% fill_gaps() %>%
  model(
    mod_1=ARIMA(NO1_diff),
    mod_2=ARIMA(NO1_diff~Kvote_diff),
    mod_3=ARIMA(NO1_diff~Kvote_diff+Gass_diff), 
    mod_4=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff),
    mod_5=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Oslo_diff),
    mod_6vann=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Oslo_diff+Vann_diff),
    mod_6kull=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Oslo_diff+Kull_diff),
    mod_6vann1=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Oslo_diff+Vann_diff+Kull_diff),
    mod_6vann2=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Oslo_diff+Vann_diff+Olje_diff),
    mod_6kull1=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Oslo_diff+Kull_diff+Olje_diff),
    mod_6kull2=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Oslo_diff+Kull_diff+Vann_diff)
    
    
  )

fit_6variabler
glance(fit_6variabler)
glance(fit_6variabler) %>% arrange(AICc)
fit_6variabler %>%select(mod_6vann) %>% report()



fit_7variabler= fase4%>% fill_gaps() %>%
  model(
    mod_1=ARIMA(NO1_diff),
    mod_2=ARIMA(NO1_diff~Kvote_diff),
    mod_3=ARIMA(NO1_diff~Kvote_diff+Gass_diff), 
    mod_4=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff),
    mod_5=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Oslo_diff),
    mod_6vann=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Oslo_diff+Vann_diff),
    mod_6kull=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Oslo_diff+Kull_diff),
    mod_6begge=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Oslo_diff+Vann_diff+Kull_diff),
    mod_7vann=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Oslo_diff+Vann_diff+Olje_diff),
    mod_7kull=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Oslo_diff+Kull_diff+Olje_diff),
    mod_7begge=ARIMA(NO1_diff~Kvote_diff+Gass_diff+Vind_diff+Oslo_diff+Vann_diff+Kull_diff+Olje_diff),
    
    
    
    
  )

fit_7variabler
glance(fit_7variabler)
glance(fit_7variabler) %>% arrange(AICc)

fit_7variabler %>%select(mod_6vann) %>% report()




####################inkluderer bare karbonvariabler######################################3

it_diff_kvotelag= fase2%>% fill_gaps() %>%
  model(
    mod_kvote=ARIMA(NO1_diff~Kvote_diff, stepwise = FALSE),
    mod_kvote1=ARIMA(NO1_diff~Kvote_diff+lag(Kvote_diff), stepwise = FALSE), 
    mod_kvote2=ARIMA(NO1_diff~Kvote_diff+lag(Kvote_diff)+lag(Kvote_diff,2), stepwise = FALSE), 
    mod_kvote3=ARIMA(NO1_diff~Kvote_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3), stepwise = FALSE), 
    mod_kvote4=ARIMA(NO1_diff~Kvote_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4), stepwise = FALSE),
    mod_kvote5=ARIMA(NO1_diff~Kvote_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5), stepwise = FALSE), 
    mod_kvote6=ARIMA(NO1_diff~Kvote_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6), stepwise = FALSE), 
    mod_kvote7=ARIMA(NO1_diff~Kvote_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7), stepwise = FALSE),
    mod_kvote8=ARIMA(NO1_diff~Kvote_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8), stepwise = FALSE),
    mod_kvote9=ARIMA(NO1_diff~Kvote_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8) +lag(Kvote_diff,9), stepwise = FALSE),
    mod_kvote10=ARIMA(NO1_diff~Kvote_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10), stepwise = FALSE),
    mod_kvote11=ARIMA(NO1_diff~Kvote_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11), stepwise = FALSE),
    mod_kvote12=ARIMA(NO1_diff~Kvote_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12), stepwise = FALSE),
    mod_kvote13=ARIMA(NO1_diff~Kvote_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12)+lag(Kvote_diff,13), stepwise = FALSE),
    mod_kvote14=ARIMA(NO1_diff~Kvote_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12)+lag(Kvote_diff,13)+lag(Kvote_diff,14), stepwise = FALSE)
    
    
    
    
  )

fit_diff_kvotelag
glance(fit_diff_kvotelag)
glance(fit_diff_kvotelag) %>% arrange(AICc)
glance(fit_diff_kvotelag) %>% arrange(BIC)


fit_diff_kvotelag %>%select(mod_kvote7) %>% report()
fit_diff_kvotelag %>%select(mod_kvote14) %>% report()

#ljung-box test, gjøres også for senere modeller  
augment(fit_diff_kvotelag%>% select(mod_kvote14)) %>%features(.innov, ljung_box, lag =21, dof=20)


fit_diff_kvotelag %>%
  select(mod_kvote7) %>% report() %>%
  gg_tsresiduals()

resids=fit_diff_kvotelag %>%select(mod_kvote5) %>% residuals()

acf(resids, na.action=na.pass,lag.max=5,  main="SARIMAX(5,1,0) med kvote og 14 lags (NO1)") #da ignorerer den na-verdiene 
pacf(resids, na.action=na.pass,lag.max=30, main="SARIMAX(5,1,0)(1,0,0) med kvote og 5 lags (NO1)") 


#Bar-plott,
koeff.mod=c( 0.0731     ,      0.0466       ,      -0.4879      ,       -1.1967        ,      0.0354,  1.0176   ,          -0.0841     ,        -0.5449       ,      -0.0909       ,       0.4729      ,         0.2507       ,       -0.4285 , 0.0627         ,      1.1663)   #sett inn kvote koeffisientene til modellen
barplot(koeff.mod, main="Kvotevariabler til modell med kvote og 13 lags (NO1)", col="darkgreen")


fit_gass= fase4%>% fill_gaps() %>%
  model(
    mod_kvote=ARIMA(NO1_diff~Kvote_diff+Gass_diff, stepwise = FALSE),
    mod_kvote1=ARIMA(NO1_diff~Kvote_diff+Gass_diff+lag(Kvote_diff), stepwise = FALSE), 
    mod_kvote2=ARIMA(NO1_diff~Kvote_diff+Gass_diff+lag(Kvote_diff)+lag(Kvote_diff,2), stepwise = FALSE), 
    mod_kvote3=ARIMA(NO1_diff~Kvote_diff+Gass_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3), stepwise = FALSE), 
    mod_kvote4=ARIMA(NO1_diff~Kvote_diff+Gass_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4), stepwise = FALSE),
    mod_kvote5=ARIMA(NO1_diff~Kvote_diff+Gass_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5), stepwise = FALSE), 
    mod_kvote6=ARIMA(NO1_diff~Kvote_diff+Gass_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6), stepwise = FALSE), 
    mod_kvote7=ARIMA(NO1_diff~Kvote_diff+Gass_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7), stepwise = FALSE),
    mod_kvote8=ARIMA(NO1_diff~Kvote_diff+Gass_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8), stepwise = FALSE),
    mod_kvote9=ARIMA(NO1_diff~Kvote_diff+Gass_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8) +lag(Kvote_diff,9), stepwise = FALSE),
    mod_kvote10=ARIMA(NO1_diff~Kvote_diff+Gass_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10), stepwise = FALSE),
    mod_kvote11=ARIMA(NO1_diff~Kvote_diff+Gass_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11), stepwise = FALSE),
    mod_kvote12=ARIMA(NO1_diff~Kvote_diff+Gass_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12), stepwise = FALSE),
    mod_kvote13=ARIMA(NO1_diff~Kvote_diff+Gass_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12)+lag(Kvote_diff,13), stepwise = FALSE),
    mod_kvote14=ARIMA(NO1_diff~Kvote_diff+Gass_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12)+lag(Kvote_diff,13)+lag(Kvote_diff,14), stepwise = FALSE)
    
    
    
    
  )



fit_gass
glance(fit_diff_kvotelag)
glance(fit_gass) %>% arrange(AICc)
glance(fit_gass) %>% arrange(BIC)

fit_gass %>%select(mod_kvote) %>% report()
fit_gass %>%select(mod_kvote14) %>% report()
fit_gass %>%select(mod_kvote13) %>% report()



#acf og pacf + ljung-box test  gjøres for alle modeller

resids=fit_gass%>%select(mod_kvote13) %>% residuals()
augment(fit_gass%>% select(mod_kvote13)) %>%features(.innov, ljung_box, lag =22, dof=21)

acf(resids, na.action=na.pass, lag.max = 100, main="SARIMAX(5,1,0)(1,0,0) med kvote, 13 lags kvote og gass(NO1)") #da ignorerer den na-verdiene 
pacf(resids, na.action=na.pass, lag.max=100, main="SARIMAX(5,1,0)(1,0,0) med kvote, 13 lags kvote og gass(NO1)") 

#Bar-plott, gjøres for alle modeller med lags
koeff.mod=c(0.4023 ,0.1788        ,    -0.5585       ,     -0.7883 , 0.3833    ,        0.9503  ,        -0.1909    ,       -0.5876       ,   -0.2693        ,    -0.0242       ,      0.2424,  -0.4307       ,       0.0859        ,     1.0022)   #sett inn kvote koeffisientene til modellen
barplot(koeff.mod, main="Kvotevariabler til modell med kvote, 13 lags kvote og gass (NO1)", col="darkgreen")






fit_kull= fase2%>% fill_gaps() %>%
  model(
    mod_kvote=ARIMA(NO1_diff~Kvote_diff+Kull_diff, stepwise = FALSE),
    mod_kvote1=ARIMA(NO1_diff~Kvote_diff+Kull_diff+lag(Kvote_diff), stepwise = FALSE), 
    mod_kvote2=ARIMA(NO1_diff~Kvote_diff+Kull_diff+lag(Kvote_diff)+lag(Kvote_diff,2), stepwise = FALSE), 
    mod_kvote3=ARIMA(NO1_diff~Kvote_diff+Kull_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3), stepwise = FALSE), 
    mod_kvote4=ARIMA(NO1_diff~Kvote_diff+Kull_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4), stepwise = FALSE),
    mod_kvote5=ARIMA(NO1_diff~Kvote_diff+Kull_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5), stepwise = FALSE), 
    mod_kvote6=ARIMA(NO1_diff~Kvote_diff+Kull_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6), stepwise = FALSE), 
    mod_kvote7=ARIMA(NO1_diff~Kvote_diff+Kull_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7), stepwise = FALSE),
    mod_kvote8=ARIMA(NO1_diff~Kvote_diff+Kull_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8), stepwise = FALSE),
    mod_kvote9=ARIMA(NO1_diff~Kvote_diff+Kull_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8) +lag(Kvote_diff,9), stepwise = FALSE),
    mod_kvote10=ARIMA(NO1_diff~Kvote_diff+Kull_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10), stepwise = FALSE),
    mod_kvote11=ARIMA(NO1_diff~Kvote_diff+Kull_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11), stepwise = FALSE),
    mod_kvote12=ARIMA(NO1_diff~Kvote_diff+Kull_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12), stepwise = FALSE),
    mod_kvote13=ARIMA(NO1_diff~Kvote_diff+Kull_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12)+lag(Kvote_diff,13), stepwise = FALSE),
    mod_kvote14=ARIMA(NO1_diff~Kvote_diff+Kull_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12)+lag(Kvote_diff,13)+lag(Kvote_diff,14), stepwise = FALSE)
    
    
    
    
  )

fit_kull

glance(fit_kull) %>% arrange(AICc)
glance(fit_kull) %>% arrange(BIC)

fit_kull %>%select(mod_kvote) %>% report()
fit_kull %>%select(mod_kvote7) %>% report()

fit_olje= fase4%>% fill_gaps() %>%
  model(
    mod_kvote=ARIMA(NO1_diff~Kvote_diff+Olje_diff, stepwise = FALSE),
    mod_kvote1=ARIMA(NO1_diff~Kvote_diff+Olje_diff+lag(Kvote_diff), stepwise = FALSE), 
    mod_kvote2=ARIMA(NO1_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2), stepwise = FALSE), 
    mod_kvote3=ARIMA(NO1_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3), stepwise = FALSE), 
    mod_kvote4=ARIMA(NO1_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4), stepwise = FALSE),
    mod_kvote5=ARIMA(NO1_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5), stepwise = FALSE), 
    mod_kvote6=ARIMA(NO1_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6), stepwise = FALSE), 
    mod_kvote7=ARIMA(NO1_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7), stepwise = FALSE),
    mod_kvote8=ARIMA(NO1_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8), stepwise = FALSE),
    mod_kvote9=ARIMA(NO1_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8) +lag(Kvote_diff,9), stepwise = FALSE),
    mod_kvote10=ARIMA(NO1_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10), stepwise = FALSE),
    mod_kvote11=ARIMA(NO1_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11), stepwise = FALSE),
    mod_kvote12=ARIMA(NO1_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12), stepwise = FALSE),
    mod_kvote13=ARIMA(NO1_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12)+lag(Kvote_diff,13), stepwise = FALSE),
    mod_kvote14=ARIMA(NO1_diff~Kvote_diff+Olje_diff+lag(Kvote_diff)+lag(Kvote_diff,2)+lag(Kvote_diff,3)+lag(Kvote_diff,4)+lag(Kvote_diff,5)+lag(Kvote_diff,6)+lag(Kvote_diff,7) +lag(Kvote_diff,8)+lag(Kvote_diff,9)+lag(Kvote_diff,10)+lag(Kvote_diff,11)+lag(Kvote_diff,12)+lag(Kvote_diff,13)+lag(Kvote_diff,14), stepwise = FALSE)
    
    
    
    
  )

fit_olje

glance(fit_olje) %>% arrange(AICc)
glance(fit_olje) %>% arrange(BIC)

fit_olje %>%select(mod_kvote7) %>% report()


